(*
 * LANGUAGE    : ANS Forth 
 * PROJECT     : Forth Environments
 * DESCRIPTION : Converts an .EXE to an .OUT file (DB records)
 * CATEGORY    : Assembler Utility
 * AUTHOR      : Marcel Hendrix 
 * LAST CHANGE : September 24, 1995, Marcel Hendrix 
 *)



        NEEDS -miscutil

        REVISION -exe2out " .EXE to DB records  Version 0.00 "

	PRIVATES


DOC
(*
*)
ENDDOC

: EXE2OUT ( c-addr u /prefix -- )
	0 0 LOCALS| handle fsize /prefix |
	( c-addr u ) R/O BIN OPEN-FILE ?FILE TO handle
	handle FILE-SIZE ?FILE DROP TO fsize
	PAD fsize handle READ-FILE ?FILE DROP
	handle CLOSE-FILE ?FILE
	BASE @ >S HEX 
	S" a.out" W/O CREATE-FILE ?FILE TO handle
	PAD /prefix + fsize /prefix - 
	BOUNDS ?DO
		   $CR COUNT S" DB " $+
		   #16 0 DO 
			   I IF S" ," $+ ENDIF
			   J I + C@ U>D <# 'h' HOLD # # '0' HOLD #> $+ 
		       LOOP
		   handle WRITE-FILE ?FILE
	 #16 +LOOP	
	S> BASE ! handle CLOSE-FILE ?FILE ;

: STRIP ( c-addr u /prefix -- )
	0 0 0 LOCALS| 'buf handle fsize /prefix |
	( c-addr u ) R/O BIN OPEN-FILE ?FILE TO handle
	handle FILE-SIZE ?FILE DROP TO fsize
	fsize ALLOCATE ?ALLOCATE TO 'buf	
	'buf fsize handle READ-FILE ?FILE DROP
	handle CLOSE-FILE ?FILE
	S" a.out" W/O CREATE-FILE ?FILE TO handle
	'buf /prefix +  fsize /prefix -  handle WRITE-FILE ?FILE
	handle CLOSE-FILE ?FILE 
	'buf FREE ?ALLOCATE ;

: special  ( -- ) \ MMURTL
	S" 3.exe" $2200 exe2out ;

: special2 ( -- ) \ Linux
	S" 3.exe" $2200 strip ;

:ABOUT	CR ." Try:   S" &" EMIT ."  fname" &" EMIT ."  nnn EXE2OUT" ;

	DEPRIVE
	.ABOUT -exe2out CR

                              (* End of Source *)